#if !defined(AFX_ROFFPARAMETERDIALOG_H__F3A65193_9AB7_4737_AF03_A2BE35487AEF__INCLUDED_)
#define AFX_ROFFPARAMETERDIALOG_H__F3A65193_9AB7_4737_AF03_A2BE35487AEF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// RoffParameterDialog.h : header file
//

#include "RoffPhong.h"
#include "RoffPerspective.h"
#include <math.h>

/////////////////////////////////////////////////////////////////////////////
// RoffParameterDialog dialog

class RoffParameterDialog : public CDialog
{
// Construction
public:
	RoffParameterDialog(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(RoffParameterDialog)
	enum { IDD = IDD_PARAMETER_DIALOG };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(RoffParameterDialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
public:
	void setIlluminator(RoffPhong illuminator);
	RoffPhong getIlluminator();

protected:

	RoffPhong dialogIlluminator;
	RoffPerspective dialogTransformer;

	// Updates the GUI elements with values from the
	// RoffPhong object.
	void setAllValues();
	// Ray-casts a new preview using the current illumination
	// settings.
	void UpdatePreview();
	// Create a new single-color bitmap for the given
	// bitmap-ready CStatic item. Deletes the old one,
	// if any.
	void updateColorBox(int id, COLORREF color);
	// Free a CBitmap from the given CStatic item.
	void clearStaticBMP(int id);
	// Free all the CBitmaps used by this dialog.
	void clearBMPs(void);

	// Generated message map functions
	//{{AFX_MSG(RoffParameterDialog)
	afx_msg void OnExtColor();
	afx_msg void OnIntColor();
	afx_msg void OnHighColor();
	afx_msg void OnAlight();
	afx_msg void OnDlight();
	afx_msg void OnPdReset();
	afx_msg void OnAdvancedSettings();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	virtual void OnCancel();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ROFFPARAMETERDIALOG_H__F3A65193_9AB7_4737_AF03_A2BE35487AEF__INCLUDED_)
