// RoffPerspective.h: interface for the RoffPerspective class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ROFFPERSPECTIVE_H__8747CCE5_EFAC_4BEA_8B17_EFE36E8E396A__INCLUDED_)
#define AFX_ROFFPERSPECTIVE_H__8747CCE5_EFAC_4BEA_8B17_EFE36E8E396A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "RoffVector.h"
#include <math.h>

class RoffPerspective  
{
public:
	RoffPerspective();
	virtual ~RoffPerspective();

	void setFrom(const RoffVector newFrom) { fromPoint = newFrom; UpdateTransformation();}
	void setAt(const RoffVector newAt) { atPoint = newAt; UpdateTransformation();}
	void setUpVector( const RoffVector newUp) { upVector = newUp; UpdateTransformation();}
	RoffVector getFrom() const { return fromPoint; }
	RoffVector getAt() const { return atPoint; }
	RoffVector getUp() const { return upVector; }
	double getAngle() { return viewAngle; }
	void setAngle(const double newAngle);
	void zoom(const double percentage);
	void translate(const double rightPercent, const double upPercent);
	void rotate(const double upDegrees, const double rightDegrees);

	RoffVector WorldToEye(const RoffVector worldPoint) const;
	RoffVector EyeToWorld(const RoffVector eyePoint) const;
	RoffVector EyeTo2D(const RoffVector eyePoint) const;

protected:
	RoffVector fromPoint;
	RoffVector atPoint;

	RoffVector upVector;

	double viewAngle;
	double factor2D;
	RoffVector aColumn;
	RoffVector bColumn;
	RoffVector cColumn;

	void UpdateTransformation();

};

#endif // !defined(AFX_ROFFPERSPECTIVE_H__8747CCE5_EFAC_4BEA_8B17_EFE36E8E396A__INCLUDED_)
