// RoffPhong.h: interface for the RoffPhong class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ROFFPHONG_H__89B2A67D_BC48_4C2A_8DB0_CF914A7C3241__INCLUDED_)
#define AFX_ROFFPHONG_H__89B2A67D_BC48_4C2A_8DB0_CF914A7C3241__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "RoffVector.h"

class RoffPhong  
{
public:
	RoffPhong();
	virtual ~RoffPhong();

    COLORREF Illuminate(const RoffVector& normal, const RoffVector& viewDirection) const;

	void setOutsideColor(const COLORREF newColor);
	void setInsideColor(const COLORREF newColor);
    void setAmbientColor(const COLORREF newColor);
	void setDirectionalColor(const COLORREF newColor);
	void setHighlightColor(const COLORREF newColor);
	void setLightDirection(const RoffVector& newDirection);
	void setWorldLight(const RoffVector& newDirection);
	void setAmbientFactor(const double newFactor) { ambientFactor = newFactor; }
	void setDiffuseFactor(const double newFactor) { diffuseFactor = newFactor; }
	void setSpecularFactor(const double newFactor) { specularFactor = newFactor; }
    void setShininess(const double newShininess) { shininess = newShininess; }

	COLORREF getOutsideColor() const;
	COLORREF getInsideColor() const;
	COLORREF getAmbientColor() const;
	COLORREF getDirectionalColor() const;
	COLORREF getHighlightColor() const;
	RoffVector getLightDirection() const;
	RoffVector getWorldLight() const;
	double getAmbientFactor() const {return ambientFactor;}
    double getDiffuseFactor() const {return diffuseFactor;}
    double getSpecularFactor() const {return specularFactor;}
	double getShininess() const {return shininess;}

private:
    RoffVector lightDirection;
	RoffVector worldLight;

	double objOutsideRed;
	double objOutsideGreen;
	double objOutsideBlue;

	double objInsideRed;
	double objInsideGreen;
	double objInsideBlue;

	double ambientRed;
	double ambientGreen;
	double ambientBlue;

	double lightRed;
	double lightGreen;
	double lightBlue;

	double highlightRed;
	double highlightGreen;
	double highlightBlue;

	double ambientFactor;
	double diffuseFactor;
	double specularFactor;

	double shininess;


	void SetColorSet(const COLORREF newColor, double& redPart, double& greenPart, double& bluePart);
	COLORREF RoffPhong::GetColorSet(const double redPart, const double greenPart, const double bluePart) const;
};

#endif // !defined(AFX_ROFFPHONG_H__89B2A67D_BC48_4C2A_8DB0_CF914A7C3241__INCLUDED_)
