// RoffPolygon3D.cpp: implementation of the RoffPolygon3D class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "RoffView.h"
#include "RoffPolygon3D.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

RoffPolygon3D::~RoffPolygon3D()
{

}

RoffPolygon3D::RoffPolygon3D()
{
}

// Handles construction from a string, from a single
// line of an OFF file.
RoffPolygon3D::RoffPolygon3D(char * stringVersion) {

	int numPoints = _ttoi(strtok(stringVersion, " \t"));

	vertexIndexes.SetSize(numPoints);

	for (int i = 0;i < numPoints;i++) {
	    vertexIndexes[i] = _ttoi(strtok(NULL, " \t"));
	}
}

// Copy constructor.
const RoffPolygon3D& RoffPolygon3D::operator=(const RoffPolygon3D& rhs){

	vertexIndexes.SetSize(rhs.vertexIndexes.GetSize());
	vertexIndexes.Copy(rhs.vertexIndexes);

	return *this;
}

int RoffPolygon3D::getNumEdges() {

	return vertexIndexes.GetSize();
}

RoffPolygonEdge RoffPolygon3D::getEdge(int index) {

	// Handle the special case of the edge from the last
	// point of the polygon back to the first point.
	int secondEnd = index + 1;
	if (index == vertexIndexes.GetSize() - 1) {
		secondEnd = 0;
	}

	return RoffPolygonEdge(vertexIndexes[index], vertexIndexes[secondEnd]);
}

int RoffPolygon3D::getVertex(int index) {
	return vertexIndexes[index];
}

// Outputs the polygon in OFF form:
// <numVertices> <v 0> <v 1> ... <v numVertices - 1>
CString RoffPolygon3D::toString() {

	CString rval;
	CString formatter;
	int size = vertexIndexes.GetSize();

	rval.Format("%d ",size);
	
	for (int i = 0;i < size;i++) {
		formatter.Format("%d ", vertexIndexes[i]);
		rval = rval + formatter;
		if (i < size - 1) {
			rval += " ";
		}
	}

	return rval;
}
