// RoffTriangle.cpp: implementation of the RoffTriangle class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "roffview.h"
#include "RoffTriangle.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

RoffTriangle::RoffTriangle(int point1, int point2, int point3, CArray<RoffVector, RoffVector&>* newPointArray)
{
    p1 = point1;
	p2 = point2;
	p3 = point3;
	pointArray = newPointArray;
	buildCentroid(*pointArray);
	buildNormal(*pointArray);
}

RoffTriangle::~RoffTriangle()
{

}

// Each triangle stores a vector that points to the
// viewer. This is updated by passing a new viewer
// location (fromPoint).
void RoffTriangle::updateView(RoffVector fromPoint) {

	viewVector = fromPoint - centroid;
	distance = viewVector.getLength();
	viewVector = viewVector / distance;
}

void RoffTriangle::buildCentroid(CArray<RoffVector, RoffVector&>& pointArray) {

	centroid = ((pointArray[p1] + pointArray[p2]) + pointArray[p3]) / 3.0;
}

void RoffTriangle::buildNormal(CArray<RoffVector, RoffVector&>& pointArray) {

    normal = (pointArray[p2] - pointArray[p1]).Cross((pointArray[p3] - pointArray[p1]));
	normal = normal / normal.getLength();
}

void RoffTriangle::rebuild() {
	buildCentroid(*pointArray);
	buildNormal(*pointArray);
}