// RoffTriangle.h: interface for the RoffTriangle class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ROFFTRIANGLE_H__A3A8DE42_0343_45AA_970F_DE8912AA2F83__INCLUDED_)
#define AFX_ROFFTRIANGLE_H__A3A8DE42_0343_45AA_970F_DE8912AA2F83__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "RoffVector.h"
#include <afxtempl.h>

class RoffTriangle  
{
public:
	RoffTriangle(int p1, int p2, int p3, CArray<RoffVector, RoffVector&>* pointArray);
	virtual ~RoffTriangle();

	int getP1() {return p1;}
	int getP2() {return p2;}
	int getP3() {return p3;}
	RoffVector getView() {return viewVector;}
	RoffVector getNormal() {return normal;}
	RoffVector getCentroid() {return centroid;}
	void rebuild();

	void updateView(RoffVector fromPoint);

	bool closer(RoffTriangle& rhs) {return distance < rhs.distance;}
	bool sameDepth(RoffTriangle& rhs) {return distance == rhs.distance;}

private:
	int p1;
	int p2;
	int p3;
	double distance;
	RoffVector viewVector;
	RoffVector normal;
	RoffVector centroid;
	CArray<RoffVector, RoffVector&>* pointArray;

	void buildCentroid(CArray<RoffVector, RoffVector&>& pointArray);
    void buildNormal(CArray<RoffVector, RoffVector&>& pointArray);
};

#endif // !defined(AFX_ROFFTRIANGLE_H__A3A8DE42_0343_45AA_970F_DE8912AA2F83__INCLUDED_)
