// RoffTriangleManager.h: interface for the RoffTriangleManager class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ROFFTRIANGLEMANAGER_H__420DFC0A_66E9_4CCF_BA72_797FD248D408__INCLUDED_)
#define AFX_ROFFTRIANGLEMANAGER_H__420DFC0A_66E9_4CCF_BA72_797FD248D408__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "RoffTriangle.h"
#include "RoffVector.h"
#include "RoffPolygon3D.h"
#include <afxtempl.h>

class RoffTriangleManager  
{
public:
	RoffTriangleManager();
	virtual ~RoffTriangleManager();

	void setPointArray(CArray<RoffVector, RoffVector&>* newPointArray);
	void set2DPointArrays(CArray<double, double>* newPointXArray,
		                  CArray<double, double>* newPointYArray);

	void tessellate(CArray<RoffPolygon3D, RoffPolygon3D&>* polyArray);
	void orderTriangles(RoffVector fromPoint);
	void rebuild();

	RoffTriangle* get(int triangleIndex);
	void setScreenFactor(int newScreenFactor) {screenFactor = newScreenFactor;}
	CPoint* getCPoints(int triangleIndex);
	int getNumTriangles() {return numTriangles;}

private:
	CArray<RoffVector, RoffVector&>* pointArray;
    CArray<double, double>* pointXArray;
    CArray<double, double>* pointYArray;
	CArray<int, int> depthOrder;
	CArray<RoffTriangle*, RoffTriangle*&> triangles;
	int numTriangles;
	int screenFactor;

	void Heapify(int index, int heapsize);
};

#endif // !defined(AFX_ROFFTRIANGLEMANAGER_H__420DFC0A_66E9_4CCF_BA72_797FD248D408__INCLUDED_)
