// RoffVector.h: interface for the RoffVector class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ROFFVECTOR_H__2C069296_A658_4EEE_BD86_7806F53285A6__INCLUDED_)
#define AFX_ROFFVECTOR_H__2C069296_A658_4EEE_BD86_7806F53285A6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <math.h>

class RoffVector  
{
public:
	RoffVector();
	RoffVector(double newX, double newY, double newZ);
	virtual ~RoffVector();

	double x;
	double y;
	double z;

	RoffVector operator+(const RoffVector& rhs) const;
	RoffVector operator-(const RoffVector& rhs) const;
	RoffVector operator*(const double factor) const;
	RoffVector operator/(const double factor) const;


	double getLength() const;
	double getSquaredLength() const;
	RoffVector Cross(const RoffVector& rhs) const;
	double Dot(const RoffVector& rhs) const;
	RoffVector rotate(const RoffVector axis, double degrees) const;
};

#endif // !defined(AFX_ROFFVECTOR_H__2C069296_A658_4EEE_BD86_7806F53285A6__INCLUDED_)
