// RoffViewDoc.cpp : implementation of the CRoffViewDoc class
//

#include "stdafx.h"
#include "RoffView.h"

#include "RoffViewDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRoffViewDoc

IMPLEMENT_DYNCREATE(CRoffViewDoc, CDocument)

BEGIN_MESSAGE_MAP(CRoffViewDoc, CDocument)
	//{{AFX_MSG_MAP(CRoffViewDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRoffViewDoc construction/destruction

CRoffViewDoc::CRoffViewDoc()
{
	numVertices        = 0;
	numPolygons        = 0;
	numEdges           = 0;
	numUniqueEdges     = 0;
	largestPolygonSize = 0;
	maxX = .5;
	minX = -.5;
	maxY = .5;
	minY = -.5;
	maxZ = .5;
	minZ = -.5;
}

CRoffViewDoc::~CRoffViewDoc()
{
}

BOOL CRoffViewDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CRoffViewDoc serialization

void CRoffViewDoc::Serialize(CArchive& ar)
{
	int i;

	if (ar.IsStoring())
	{
		ar.WriteString("OFF\r\n");
		CString writeLine;
		writeLine.Format("%d %d %d\r\n", numVertices, numPolygons, numEdges);
		ar.WriteString(writeLine);
		
		for (i = 0;i < numVertices;i++) {
			writeLine.Format("%f %f %f", vertices[i].x, vertices[i].y, vertices[i].z);
			ar.WriteString(writeLine);
			ar.WriteString("\r\n");
		}

		for (i = 0;i < numPolygons;i++) {
			ar.WriteString(polygons[i].toString());
			ar.WriteString("\r\n");
		}
	}
	else
	{
		bool goodLoad = true;

		// Temporary variables to load into, so if
		// the load fails we haven't corrupted the
		// current data.
		int inPoints = 0;
		int inPolygons = 0;
		int inTotalEdges = 0;
		int inLargestPolygonSize = 0;
		double inMinX = 0;
		double inMaxX = 0;
		double inMinY = 0;
		double inMaxY = 0;
		double inMinZ = 0;
		double inMaxZ = 0;
		CArray<RoffVector, RoffVector&> inVertices;
		CArray<RoffPolygon3D, RoffPolygon3D&> inPolys;
		CString readString;
		int spaceIndex = 0;
        const char whiteSpace[] = " \t\n";
		const LPTSTR tempString = new TCHAR[128];

		ar.ReadString(readString); // Remove the 'OFF'
		if (readString != "OFF") {
			goodLoad = false;
		}

		ar.ReadString(readString);
		_tcscpy(tempString, readString);

		inPoints = _ttoi(strtok(tempString, whiteSpace));
		inPolygons = _ttoi(strtok(NULL, whiteSpace));

		// The number of edges in the file is still
		// in tempString, but we will calculate the
		// edges from the polygons, instead of using
		// this value.
		
		if ((goodLoad) &&
			(inPoints > 0) &&
			(inPolygons > 0)
			) {
			inVertices.SetSize(inPoints);
			inPolys.SetSize(inPolygons);
		} else {
			goodLoad = false;
		}

		if (goodLoad) {
			ar.ReadString(readString);
			_tcscpy(tempString, readString);

			inVertices[0].x = atof(strtok(tempString, whiteSpace));
			inMaxX = inVertices[0].x;
			inMinX = inVertices[0].x;

			inVertices[0].y = atof(strtok(NULL, whiteSpace));
			inMaxY = inVertices[0].y;
			inMinY = inVertices[0].y;

			inVertices[0].z = atof(strtok(NULL, whiteSpace));
			inMaxZ = inVertices[0].z;
			inMinZ = inVertices[0].z;
			

			for (int i = 1;i < inPoints;i++) {
				ar.ReadString(readString);
				_tcscpy(tempString, readString);

				inVertices[i].x = atof(strtok(tempString, whiteSpace));
				if (inVertices[i].x > inMaxX) {
					inMaxX = inVertices[i].x;
				} else if (inVertices[i].x < inMinX) {
					inMinX = inVertices[i].x;
				}

				inVertices[i].y = atof(strtok(NULL, whiteSpace));
				if (inVertices[i].y > inMaxY) {
					inMaxY = inVertices[i].y;
				} else if (inVertices[i].y < inMinY) {
					inMinY = inVertices[i].y;
				}

				inVertices[i].z = atof(strtok(NULL, whiteSpace));
				if (inVertices[i].z > inMaxZ) {
					inMaxZ = inVertices[i].z;
				} else if (inVertices[i].z < inMinZ) {
					inMinZ = inVertices[i].z;
				}
			}
		}

		if (goodLoad) {
			int polygonSize = 0;
			for (int i = 0;i < inPolygons;i++) {
				ar.ReadString(readString);
				readString.TrimLeft();
				while (readString.GetLength() < 1) {
				    ar.ReadString(readString);
				    readString.TrimLeft();
				}
				_tcscpy(tempString, readString);
				inPolys[i] = RoffPolygon3D(tempString);
				polygonSize = inPolys[i].getNumEdges();
				inTotalEdges = inTotalEdges + polygonSize;
				if (polygonSize > inLargestPolygonSize) {
					inLargestPolygonSize = polygonSize;
				}
			}
		}

		if (goodLoad) {
		    numVertices = inPoints;
		    numPolygons = inPolygons;
		    numEdges = inTotalEdges;
			largestPolygonSize = inLargestPolygonSize;

			vertices.SetSize(numVertices);
			vertices.Copy(inVertices);
			polygons.SetSize(numPolygons);
			polygons.Copy(inPolys);
			minX = inMinX;
			maxX = inMaxX;
			minY = inMinY;
			maxY = inMaxY;
			minZ = inMinZ;
			maxZ = inMaxZ;
			BuildEdges();
		}
		delete tempString;
	}
}

/////////////////////////////////////////////////////////////////////////////
// CRoffViewDoc diagnostics

#ifdef _DEBUG
void CRoffViewDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CRoffViewDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CRoffViewDoc commands

void CRoffViewDoc::DeleteContents() 
{
    numVertices        = 0;
    numPolygons        = 0;
    numEdges           = 0;
	numUniqueEdges     = 0;
	largestPolygonSize = 0;
	maxX = .5;
	minX = -.5;
	maxY = .5;
	minY = -.5;
	maxZ = .5;
	minZ = -.5;

	vertices.RemoveAll();
	polygons.RemoveAll();
	
	CDocument::DeleteContents();
}

void CRoffViewDoc::BuildEdges() {

	// Initialize the number of unique edges found
	// to zero.
	numUniqueEdges = 0;

	edges.SetSize(numEdges);

	// Two variables for moving through the edge list.
	int currentEdges;
	RoffPolygonEdge testEdge;

	// Declare two variables for a linear search.
	// Not fast, but we only need to build this once
	// per file load, and it can be done in place.
	bool found;
	int  searchIndex;

	// For every polygon in the model
	for (int i = 0;i < numPolygons;i++) {
		// For every edge in the polygon
		currentEdges = polygons[i].getNumEdges();
		for (int j = 0; j < currentEdges; j++) {
			// Retrieve the edge.
			testEdge = polygons[i].getEdge(j);
			// Check if we already have the edge
			searchIndex = 0;
			found = false;
			while (searchIndex < numUniqueEdges && !found) {
				// This check will match uniques,
				// because the edge returned from the
				// polygon is guaranteed to have the
				// smaller of the two indexes first,
				// so we don't need to check both
				// directions.
				if (edges[searchIndex].startIndex == testEdge.startIndex) {
					if (edges[searchIndex].endIndex == testEdge.endIndex) {
					    found = true;
					}
				}
				searchIndex++;
			}
			// If we don't have it
			if (!found) {
				// Add it to our collection.
				edges[numUniqueEdges] = testEdge;
				// And count it
				numUniqueEdges = numUniqueEdges + 1;
			}
		}
	}

	edges.SetSize(numUniqueEdges);
}

RoffVector CRoffViewDoc::getPoint(int index) const {

	int vertIndex = edges[index / 2].startIndex;

	if (index % 2 != 0) {
		vertIndex = edges[index / 2].endIndex;
	}

	return vertices[vertIndex];
}

int CRoffViewDoc::getPointIndex(int index) const {

	int vertIndex = edges[index / 2].startIndex;

	if (index % 2 != 0) {
		vertIndex = edges[index / 2].endIndex;
	}

	return vertIndex;
}

