// RoffViewDoc.h : interface of the CRoffViewDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_ROFFVIEWDOC_H__413DB5C0_196A_4598_9478_4E25E3FA3CC5__INCLUDED_)
#define AFX_ROFFVIEWDOC_H__413DB5C0_196A_4598_9478_4E25E3FA3CC5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <afxtempl.h>
#include "RoffVector.h"
#include "RoffPolygon3D.h"
#include "RoffPolygonEdge.h"

class CRoffViewDoc : public CDocument
{
protected: // create from serialization only
	CRoffViewDoc();
	DECLARE_DYNCREATE(CRoffViewDoc)

	void BuildEdges();

// Attributes
public:
	CArray<RoffVector, RoffVector&> vertices;
	CArray<RoffPolygon3D, RoffPolygon3D&> polygons;
	CArray<RoffPolygonEdge, RoffPolygonEdge&> edges;

	int numVertices;
	int numPolygons;
	int numEdges;
    int numUniqueEdges;
	int largestPolygonSize;

	double maxX;
	double minX;
	double maxY;
	double minY;
	double maxZ;
	double minZ;

// Operations
public:

	RoffVector getPoint(int index) const;
	int getPointIndex(int index) const;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRoffViewDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual void DeleteContents();
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CRoffViewDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CRoffViewDoc)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ROFFVIEWDOC_H__413DB5C0_196A_4598_9478_4E25E3FA3CC5__INCLUDED_)
