// RoffViewView.h : interface of the CRoffViewView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_ROFFVIEWVIEW_H__BA09A529_5708_4FF8_9185_CEE69D32A59C__INCLUDED_)
#define AFX_ROFFVIEWVIEW_H__BA09A529_5708_4FF8_9185_CEE69D32A59C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "RoffPhong.h"
#include "RoffPerspective.h"
#include "RoffVector.h"
#include "RoffTriangle.h"
#include "RoffTriangleManager.h"

class CRoffViewView : public CView
{
protected: // create from serialization only
	CRoffViewView();
	DECLARE_DYNCREATE(CRoffViewView)
	void BuildBuffer();
	void BuildStructures();

// Attributes
	CDC* pMemDC;
	COLORREF bgColor;
	int upperX;
	int upperY;
	int squareSize;

	int numPoints;
	CArray<double, double> convertedXPoints;
	CArray<double, double> convertedYPoints;

	// Only one of these three should be true at a
	// time. 
	bool drawWireframe;
	bool drawPolygons;
	bool drawPoints;

	// Only one of these two should be true at a
	// time.
	bool viewMode;
	bool controlMode;

	bool lmouseDown;
	bool rmouseDown;
	CPoint lastClickPoint;

	// This is the index of the selected point, or -1
	// if no point is selected.
	int selectedPoint;

	RoffPerspective     transformer;
	RoffPhong           illuminator;
	RoffTriangleManager tmanager;

public:
	CRoffViewDoc* GetDocument();
    void SetDefaultPerspective();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRoffViewView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CRoffViewView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CRoffViewView)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnChangeBGColor();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnViewModelInfo();
	afx_msg void OnToolsResetview();
	afx_msg void OnParameterDialog();
	afx_msg void OnViewParameters();
	afx_msg void OnViewSolid();
	afx_msg void OnUpdateViewSolid(CCmdUI* pCmdUI);
	afx_msg void OnViewWire();
	afx_msg void OnUpdateViewWire(CCmdUI* pCmdUI);
	afx_msg void OnUpdateViewPoints(CCmdUI* pCmdUI);
	afx_msg void OnViewPoints();
	afx_msg void OnEditCopy();
	afx_msg void OnControlEdit();
	afx_msg void OnUpdateControlEdit(CCmdUI* pCmdUI);
	afx_msg void OnControlView();
	afx_msg void OnUpdateControlView(CCmdUI* pCmdUI);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in RoffViewView.cpp
inline CRoffViewDoc* CRoffViewView::GetDocument()
   { return (CRoffViewDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ROFFVIEWVIEW_H__BA09A529_5708_4FF8_9185_CEE69D32A59C__INCLUDED_)
